<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::certifiedSender::CertifiedSender Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1certified_sender.html">certifiedSender</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">CertifiedSender</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::certifiedSender::CertifiedSender Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_certified_sender_8h_source.html">CertifiedSender.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::certifiedSender::CertifiedSender:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_inherit__map" id="alexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html" title="alexaClientSDK::avsCommon\l::utils::RequiresShutdown" alt="" coords="17,5,214,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ConnectionStatus\lObserverInterface" alt="" coords="5,68,226,120"/>
<area shape="rect" id="node5" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html" title="alexaClientSDK::registration\lManager::CustomerDataHandler" alt="" coords="9,207,223,245"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::certifiedSender::CertifiedSender:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_coll__map" id="alexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html" title="alexaClientSDK::avsCommon\l::utils::RequiresShutdown" alt="" coords="17,5,214,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ConnectionStatus\lObserverInterface" alt="" coords="5,68,226,120"/>
<area shape="rect" id="node5" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html" title="alexaClientSDK::registration\lManager::CustomerDataHandler" alt="" coords="9,207,223,245"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a608f4f183ba3a796b5f6b3748c792e20"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a608f4f183ba3a796b5f6b3748c792e20">~CertifiedSender</a> ()</td></tr>
<tr class="separator:a608f4f183ba3a796b5f6b3748c792e20"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c0706d79717b226ba77d1a9c3280fe6"><td class="memItemLeft" align="right" valign="top">std::future&lt; bool &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a4c0706d79717b226ba77d1a9c3280fe6">sendJSONMessage</a> (const std::string &amp;jsonMessage)</td></tr>
<tr class="separator:a4c0706d79717b226ba77d1a9c3280fe6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cb617379260eb52dfde94f0a41798a9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a6cb617379260eb52dfde94f0a41798a9">clearData</a> () override</td></tr>
<tr class="separator:a6cb617379260eb52dfde94f0a41798a9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></td></tr>
<tr class="memitem:aae7174ed932ae1413460255238c4422b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#aae7174ed932ae1413460255238c4422b">RequiresShutdown</a> (const std::string &amp;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a>)</td></tr>
<tr class="separator:aae7174ed932ae1413460255238c4422b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">~RequiresShutdown</a> ()</td></tr>
<tr class="memdesc:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">More...</a><br /></td></tr>
<tr class="separator:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a745cd4dc404db52f7d0afbf838454fac inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a> () const</td></tr>
<tr class="separator:a745cd4dc404db52f7d0afbf838454fac inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a350a147e52eb3ad3c1326e6639861066 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown</a> ()</td></tr>
<tr class="separator:a350a147e52eb3ad3c1326e6639861066 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9352626109735aba40b5fb310913355 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#af9352626109735aba40b5fb310913355">isShutdown</a> () const</td></tr>
<tr class="separator:af9352626109735aba40b5fb310913355 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ConnectionStatusObserverInterface</a></td></tr>
<tr class="memitem:adec117d33ac22d7509b1e01232529782 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#adec117d33ac22d7509b1e01232529782">~ConnectionStatusObserverInterface</a> ()=default</td></tr>
<tr class="separator:adec117d33ac22d7509b1e01232529782 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html">alexaClientSDK::registrationManager::CustomerDataHandler</a></td></tr>
<tr class="memitem:a2246fb7b5773b2d9643e880bde58acf9 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a2246fb7b5773b2d9643e880bde58acf9">CustomerDataHandler</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">CustomerDataManager</a> &gt; customerDataManager)</td></tr>
<tr class="separator:a2246fb7b5773b2d9643e880bde58acf9 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a067f8855e7ac0c05fc190b6b2e8e2d19 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a067f8855e7ac0c05fc190b6b2e8e2d19">~CustomerDataHandler</a> ()</td></tr>
<tr class="separator:a067f8855e7ac0c05fc190b6b2e8e2d19 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a2635a30a4753cbc28b6c952cc27a623b"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">CertifiedSender</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a2635a30a4753cbc28b6c952cc27a623b">create</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_sender_interface.html">avsCommon::sdkInterfaces::MessageSenderInterface</a> &gt; messageSender, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_a_v_s_connection_manager_interface.html">avsCommon::sdkInterfaces::AVSConnectionManagerInterface</a> &gt; connection, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_message_storage_interface.html">MessageStorageInterface</a> &gt; storage, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">registrationManager::CustomerDataManager</a> &gt; dataManager)</td></tr>
<tr class="separator:a2635a30a4753cbc28b6c952cc27a623b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ConnectionStatusObserverInterface</a></td></tr>
<tr class="memitem:a2e6b08990caa9d1911b01d51d92806b4 inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#a2e6b08990caa9d1911b01d51d92806b4">Status</a> { <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#a2e6b08990caa9d1911b01d51d92806b4a99c8ce56e7ab246445d3b134724428f3">Status::DISCONNECTED</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#a2e6b08990caa9d1911b01d51d92806b4ac69f06e1a9b016d133907b4e5f5864d2">Status::PENDING</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#a2e6b08990caa9d1911b01d51d92806b4aa5afd6edd5336d91316964e493936858">Status::CONNECTED</a>
 }</td></tr>
<tr class="separator:a2e6b08990caa9d1911b01d51d92806b4 inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec54cdb601e5f93a516400d99663d11e inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11e">ChangedReason</a> { <br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eab50339a10e1de285ac99d4c3990b8693">ChangedReason::NONE</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11ead0749aaba8b833466dfcbb0428e4f89c">ChangedReason::SUCCESS</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eaa0d7ca35e85a9f7eb269d17c780ab691">ChangedReason::UNRECOVERABLE_ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11ea5cd351b726751149c0464e3d9c23dcf1">ChangedReason::ACL_CLIENT_REQUEST</a>, 
<br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eaa81589ff9e0102b95f3eafce18463d1a">ChangedReason::ACL_DISABLED</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eaff2281b1a4e2df717c0cc8019eacfab6">ChangedReason::DNS_TIMEDOUT</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11ea1e5d3c84593c457cee72e18634f28914">ChangedReason::CONNECTION_TIMEDOUT</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11ea8ca1e58168f20f0b69f8ae91fd3426f7">ChangedReason::CONNECTION_THROTTLED</a>, 
<br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eaabd298f8599f681c645d152c354f24de">ChangedReason::INVALID_AUTH</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11ea2e03079aa2f230632487842f6cce997a">ChangedReason::PING_TIMEDOUT</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11ea97af85d432104a37a1d183a76f05ad98">ChangedReason::WRITE_TIMEDOUT</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eacc3d4fecdd44cc6a7090ead5bcdc89a0">ChangedReason::READ_TIMEDOUT</a>, 
<br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eaafb0ae7bf77c6f70390d3658d3e12033">ChangedReason::FAILURE_PROTOCOL_ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eae8c0c70879b5895c615677261d64a1ee">ChangedReason::INTERNAL_ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11ea6a701b3f16c45b9d96fec4ac97805d9c">ChangedReason::SERVER_INTERNAL_ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eac15c6f3c089148a1bfa565ab4efea186">ChangedReason::SERVER_SIDE_DISCONNECT</a>, 
<br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11eacb2bd81ff7f58b2c6782fe390a723bbe">ChangedReason::SERVER_ENDPOINT_CHANGED</a>
<br />
 }</td></tr>
<tr class="separator:aec54cdb601e5f93a516400d99663d11e inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">This class provides a guaranteed message delivery service to AVS. Upon calling the single api, <code>sendJSONMessage</code>, this class will persist the message and continually attempt sending it until it succeeds. The persistence will work across application runs, dependent on the nature of the storage object provided.</p>
<p class="">To avoid excessive memory usage, the maximum number of messages stored in this way is configurable via the settings 'queueSizeWarnLimit' and 'queueSizeHardLimit', under the configuration root '<a class="el" href="namespacealexa_client_s_d_k_1_1certified_sender.html">certifiedSender</a>'.</p>
<p class="">Similarly, the file path for the database storage is configured under the setting 'databaseFilePath'.</p>
<p class="">This class maintains the ordering of messages passed to it. For example, if <code>sendJSONMessage</code> is invoked with messages A then B then C, then this class guarantees that the messages will be sent to AVS in the same order - A then B then C. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a608f4f183ba3a796b5f6b3748c792e20"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a608f4f183ba3a796b5f6b3748c792e20">&#9670;&nbsp;</a></span>~CertifiedSender()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::certifiedSender::CertifiedSender::~CertifiedSender </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6cb617379260eb52dfde94f0a41798a9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6cb617379260eb52dfde94f0a41798a9">&#9670;&nbsp;</a></span>clearData()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::certifiedSender::CertifiedSender::clearData </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Clear all messages that we are currently storing </p>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a36e0bb31b4187dbc04141aca7209f4c5">alexaClientSDK::registrationManager::CustomerDataHandler</a>.</p>

</div>
</div>
<a id="a2635a30a4753cbc28b6c952cc27a623b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2635a30a4753cbc28b6c952cc27a623b">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">CertifiedSender</a> &gt; alexaClientSDK::certifiedSender::CertifiedSender::create </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_sender_interface.html">avsCommon::sdkInterfaces::MessageSenderInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>messageSender</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_a_v_s_connection_manager_interface.html">avsCommon::sdkInterfaces::AVSConnectionManagerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>connection</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_message_storage_interface.html">MessageStorageInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>storage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">registrationManager::CustomerDataManager</a> &gt;&#160;</td>
          <td class="paramname"><em>dataManager</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This function creates a new instance of a <code><a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">CertifiedSender</a></code>. If it fails for any reason, <code>nullptr</code> is returned.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messageSender</td><td>The entity which is able to send <code>MessageRequests</code> to AVS. </td></tr>
    <tr><td class="paramname">connection</td><td>The connection which may be observed to determine connection status. </td></tr>
    <tr><td class="paramname">storage</td><td>The object which manages persistent storage of messages to be sent. </td></tr>
    <tr><td class="paramname">dataManager</td><td>A dataManager object that will track the CustomerDataHandler. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A <code><a class="el" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">CertifiedSender</a></code> object, or <code>nullptr</code> if there is any problem. </dd></dl>

</div>
</div>
<a id="a4c0706d79717b226ba77d1a9c3280fe6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4c0706d79717b226ba77d1a9c3280fe6">&#9670;&nbsp;</a></span>sendJSONMessage()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::future&lt; bool &gt; alexaClientSDK::certifiedSender::CertifiedSender::sendJSONMessage </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>jsonMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Function to request a message be sent to AVS. Since this class is strictly responsible for sending a message to AVS, the parameter is explicitly described as being in JSON format. This will be expected to take the form of some kind of Event which AVS understands. While the sending of the message is entirely asynchronous, the future returned allows the caller to know if the request was successfully persisted. Once the message is persisted, the caller can expect the message to be sent to AVS at some point in the future by this class.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">jsonMessage</td><td>The message to be sent to AVS. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A future expressing if the message was successfully persisted. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/CertifiedSender/include/CertifiedSender/<a class="el" href="_certified_sender_8h_source.html">CertifiedSender.h</a></li>
<li>/workplace/avs-device-sdk/CertifiedSender/src/<a class="el" href="_certified_sender_8cpp.html">CertifiedSender.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
